<template>
  <TcReportLayout format="A3">
    <template #params>
      <TcContextSelect v-model="params" />
      <div class="row q-col-gutter-x-md">
        <div class="col-6">
          <TcI2sNumberInput v-model="params.redTagGoalThreshold" label="Red tag goal threshold" unit-type="percents" />
        </div>
        <div class="col-6">
          <TcI2sNumberInput
            v-model="params.yellowTagGoalThreshold"
            label="Yellow tag goal threshold"
            unit-type="percents"
          />
        </div>
        <div class="col-6">
          <TcI2sNumberInput
            v-model="params.inspectedTyresGoalThreshold"
            label="Inspected tyres goal threshold"
            unit-type="percents"
          />
        </div>
      </div>
    </template>

    <TcPager v-if="data">
      <div class="row q-col-gutter-sm justify-around">
        <div class="col-6">
          <TcScorecard title="Number of active vehicles" :value="data.vehicles.length" />
          <TcScorecard title="Vehicles not inspected in 30 days" :value="vehiclesNotInspectedIn30Days.length" />
          <TcScorecard title="Vehicles not inspected in 60 days" :value="vehiclesNotInspectedIn60Days.length" />
          <TcScorecard title="Vehicles not inspected in 90 days" :value="vehiclesNotInspectedIn90Days.length" />
        </div>
        <div class="col-6">
          <TcHighchart title="Vehicles inspected through time" :value="vehicleInspectionAnalysisChart" />
        </div>
        <div class="col-12">
          <TcDataTable title="Last month inspections" :data="inspectionsTable" dense style="max-height: 400px;" />
        </div>
        <div class="col-6">
          <TcHighchart title="Inspected tyres vs Red Tags trend" :value="inspectedTyresVsRedTagTrend" />
        </div>
        <div class="col-6">
          <TcHighchart title="Inspected tyres vs Yellow Tags trend" :value="inspectedTyresVsYellowTagTrend" />
        </div>
        <div class="col-6">
          <TcHighchart title="Tyre observations during inspection" :value="tyreObservationsDuringInspectionChart" />
        </div>
        <div class="col-6">
          <TcDataTable title="Yellow tags" dense :data="tyreObservationsDuringInspectionTable1" />
        </div>
        <div class="col-6">
          <TcDataTable title="Red tags" dense :data="tyreObservationsDuringInspectionTable2" />
        </div>
        <div class="col-6">
          <TcDataTable title="User efficiency" dense :data="inspectionEfficiencyByUser" />
        </div>
        <div class="col-6">
          <TcScorecard title="Tyres inspected" :value="tyresInspected" />
          <TcScorecard title="Tyres inspected %" :value="tyresInspectedGoal" />
        </div>
        <div class="col-6">
          <TcScorecard title="Red Tags %" :value="redTagGoal" />
          <TcScorecard title="Yellow Tags %" :value="yellowTagGoal" />
        </div>
      </div>
    </TcPager>
  </TcReportLayout>
</template>

<script>
const dataSources = {
  locations: gql`
    query($where: TcLocationWhereInput, $cursor: String) {
      tcLocations(where: $where, cursor: $cursor) {
        nodes {
          id
          name
        }
        cursor
      }
    }
  `,
  vehicles: gql`
    query($where: TcVehicleWhereInput, $cursor: String) {
      tcVehicles(where: $where, cursor: $cursor) {
        nodes {
          id
          registrationNumber
          fleetNumber
          tcLocation {
            id
          }
          tcVehicleClass {
            id
            name
          }
          tcTyres {
            id
          }
        }
        cursor
      }
    }
  `,
  inspections: gql`
    query($where: TcVehicleEventWhereInput, $cursor: String) {
      tcVehicleEvents(where: $where, cursor: $cursor) {
        nodes {
          id
          tcVehicle {
            id
          }
          tcLocation {
            id
          }
          date
          startedAt
          finishedAt
          change
          tcUserCreatedBy {
            id
            login
            name
          }
        }
        cursor
      }
    }
  `,
}

export default {
  title: 'Inspection Dashboard',
  validations: {
    params: {
      tcFleet: { required },
    },
  },
  data() {
    return {
      params: {
        tcFleet: null,
        redTagGoalThreshold: 0.05,
        yellowTagGoalThreshold: 0.15,
        inspectedTyresGoalThreshold: 0.8,
      },
      data: null,
    }
  },
  computed: {
    tyresInspected() {
      const { inspections, vehicles } = this.data
      const inspectionsByVehicleId = _.keyBy(inspections, 'tcVehicle.id')
      const inspectedVehicles = vehicles.filter(v => inspectionsByVehicleId[v.id])
      const inspectedTyresCount = _.sum(inspectedVehicles.map(v => v.tcTyres.length))
      return inspectedTyresCount
    },
    tyresInspectedGoal() {
      const { inspections, vehicles } = this.data
      const inspectionsByVehicleId = _.keyBy(inspections, 'tcVehicle.id')
      const inspectedVehicles = vehicles.filter(v => inspectionsByVehicleId[v.id])
      const inspectedTyresCount = _.sum(inspectedVehicles.map(v => v.tcTyres.length))
      const totalTyresCount = _.sum(vehicles.map(v => v.tcTyres.length))
      const tyresInspectedPercentage = totalTyresCount ? inspectedTyresCount / totalTyresCount : 0
      return {
        value: `${_.round(tyresInspectedPercentage * 100, 2)}%`,
        color: tyresInspectedPercentage > this.params.inspectedTyresGoalThreshold ? 'positive' : 'negative',
      }
    },
    redTagGoal() {
      const { inspections, vehicles } = this.data
      const vehiclesById = _.keyBy(vehicles, 'id')
      const tyreInspectionsCount = _.sum(inspections.map(i => vehiclesById[i.tcVehicle.id]?.tcTyres.length || 0))
      const redTagCounts = inspections.map(i => {
        const redTags = i.change.observations.filter(
          o => o.tcObservation.severity === 'urgent' && o.tcVehicleEvent.id === i.id,
        )
        return redTags.length
      })
      const redTagCount = _.sum(redTagCounts)
      const redTagPercentage = redTagCount / tyreInspectionsCount
      return {
        value: `${_.round(redTagPercentage * 100, 2)}%`,
        color: redTagPercentage < this.params.redTagGoalThreshold ? 'positive' : 'negative',
      }
    },
    yellowTagGoal() {
      const { inspections, vehicles } = this.data
      const vehiclesById = _.keyBy(vehicles, 'id')
      const tyreInspectionsCount = _.sum(inspections.map(i => vehiclesById[i.tcVehicle.id]?.tcTyres.length || 0))
      const yellowTagCounts = inspections.map(i => {
        const yellowTags = i.change.observations.filter(
          o => o.tcObservation.severity === 'attention' && o.tcVehicleEvent.id === i.id,
        )
        return yellowTags.length
      })
      const yellowTagCount = _.sum(yellowTagCounts)
      const yellowTagPercentage = yellowTagCount / tyreInspectionsCount
      return {
        value: `${_.round(yellowTagPercentage * 100, 2)}%`,
        color: yellowTagPercentage < this.params.yellowTagGoalThreshold ? 'positive' : 'negative',
      }
    },
    inspectionEfficiencyByUser() {
      const step1 = _.groupBy(this.data.inspections, 'tcUserCreatedBy.login')
      const step2 = _.values(step1).map(insps => {
        const averageDuration =
          _.mean(insps.map(i => moment(i.finishedAt).valueOf() - moment(i.startedAt).valueOf()).filter(d => d > 0)) || 0
        return {
          userLogin: insps[0].tcUserCreatedBy.login,
          userName: insps[0].tcUserCreatedBy.name,
          averageDuration: moment.utc(averageDuration).format('HH:mm:ss'),
          inspectionsCount: insps.length,
        }
      })
      return _.orderBy(step2, ['inspectionsCount'], ['desc'])
    },
    tyreObservationsDuringInspectionTable1() {
      return this.observationStats
        .filter(o => o.severity === 'urgent')
        .map(os => ({
          name: os.name,
          count: os.count,
        }))
    },
    tyreObservationsDuringInspectionTable2() {
      return this.observationStats
        .filter(o => o.severity === 'urgent')
        .map(os => ({
          name: os.name,
          count: os.count,
        }))
    },
    tyreObservationsDuringInspectionChart() {
      return {
        chart: { type: 'pie' },
        series: [
          {
            data: this.observationStats.map(os => ({
              name: os.name,
              y: os.count,
            })),
          },
        ],
      }
    },
    observationStats() {
      const { inspections } = this.data
      const observations = _.flatMap(inspections, i =>
        i.change.observations.filter(o => o.tcVehicleEvent.id === i.id).map(o => o.tcObservation),
      )
      const obervationStats = _.values(_.groupBy(observations, o => o.id)).map(og => ({
        name: og[0].name,
        severity: og[0].severity,
        count: og.length,
      }))
      return _.orderBy(obervationStats, ['count'], ['desc'])
    },
    inspectedTyresVsRedTagTrend() {
      const { vehicles, inspections } = this.data
      const keys = _.range(8).map(i =>
        moment()
          .startOf('month')
          .add(-7 + i, 'months')
          .format('MMM YY'),
      )
      const vehiclesById = _.keyBy(vehicles, 'id')
      const inspectionsByMonth = _.groupBy(inspections, i => moment(i.date).format('MMM YY'))
      const values = keys.map(m => {
        const insps = inspectionsByMonth[m] || []
        const tyreInspectionsCount = _.sum(insps.map(i => vehiclesById[i.tcVehicle.id].tcTyres.length))
        const redTagsCount = _.sum(
          insps.map(i => {
            const redTags = i.change.observations.filter(
              o => o.tcObservation.severity === 'urgent' && o.tcVehicleEvent.id === i.id,
            )
            return redTags.length
          }),
        )
        return _.round((redTagsCount / tyreInspectionsCount) * 100, 3)
      })

      return {
        chart: {
          type: 'line',
        },
        xAxis: {
          categories: keys,
        },
        yAxis: {
          min: 0,
          labels: {
            format: '{value}%',
          },
        },
        series: [
          {
            type: 'spline',
            id: 'inspections',
            name: 'Red tags %',
            data: values,
          },
          {
            type: 'trendline',
            linkedTo: 'inspections',
          },
        ],
      }
    },
    inspectedTyresVsYellowTagTrend() {
      const { vehicles, inspections } = this.data
      const keys = _.range(8).map(i =>
        moment()
          .startOf('month')
          .add(-7 + i, 'months')
          .format('MMM YY'),
      )
      const vehiclesById = _.keyBy(vehicles, 'id')
      const inspectionsByMonth = _.groupBy(inspections, i => moment(i.date).format('MMM YY'))
      const values = keys.map(m => {
        const insps = inspectionsByMonth[m] || []
        const tyreInspectionsCount = _.sum(insps.map(i => vehiclesById[i.tcVehicle.id].tcTyres.length))
        const yellowTagsCount = _.sum(
          insps.map(i => {
            const yellowTags = i.change.observations.filter(
              o => o.tcObservation.severity === 'attention' && o.tcVehicleEvent.id === i.id,
            )
            return yellowTags.length
          }),
        )
        return _.round((yellowTagsCount / tyreInspectionsCount) * 100, 3)
      })

      return {
        chart: {
          type: 'line',
        },
        xAxis: {
          categories: keys,
        },
        yAxis: {
          min: 0,
          labels: {
            format: '{value}%',
          },
        },
        series: [
          {
            type: 'spline',
            id: 'inspections',
            name: 'Yellow tags %',
            data: values,
          },
          {
            type: 'trendline',
            linkedTo: 'inspections',
          },
        ],
      }
    },
    lastMonthInspections() {
      const startOfThisMonth = moment().startOf('month')
      return this.data.inspections.filter(i => moment(i.date).isSameOrAfter(startOfThisMonth))
    },
    olderInspections() {
      const startOfThisMonth = moment().startOf('month')
      return this.data.inspections.filter(i => moment(i.date).isBefore(startOfThisMonth))
    },
    vehiclesNotInspectedIn30Days() {
      const threshold = moment().add(-30, 'days')
      return this.data.vehicles.filter(
        v => !this.data.inspections.some(i => i.tcVehicle.id === v.id && moment(i.date).isSameOrAfter(threshold)),
      )
    },
    vehiclesNotInspectedIn60Days() {
      const threshold = moment().add(-60, 'days')
      return this.data.vehicles.filter(
        v => !this.data.inspections.some(i => i.tcVehicle.id === v.id && moment(i.date).isSameOrAfter(threshold)),
      )
    },
    vehiclesNotInspectedIn90Days() {
      const threshold = moment().add(-90, 'days')
      return this.data.vehicles.filter(
        v => !this.data.inspections.some(i => i.tcVehicle.id === v.id && moment(i.date).isSameOrAfter(threshold)),
      )
    },
    fleetSummaryTable() {
      const { vehicles } = this.data
      const inspectionsByVehicleId = _.keyBy(this.lastMonthInspections, 'tcVehicle.id')
      const inspectedVehicles = vehicles.filter(v => inspectionsByVehicleId[v.id])
      const vehiclesByClass = _.groupBy(vehicles, 'tcVehicleClass.name')
      const inspectedVehiclesByClass = _.groupBy(inspectedVehicles, 'tcVehicleClass.name')

      return _.keys(vehiclesByClass).map(k => {
        const vehs = _.get(vehiclesByClass, [k, 'length'])
        const inspVehs = _.get(inspectedVehiclesByClass, [k, 'length'])
        const vehsCompleted = inspVehs / vehs

        const tyres = _.sum(_.get(vehiclesByClass, k, []).map(v => v.tcTyres.length))
        const inspTyres = _.sum(_.get(inspectedVehiclesByClass, k, []).map(v => v.tcTyres.length))
        const tyresCompleted = inspTyres / tyres

        return {
          'Vehicle Class': k,
          'No. of Inspected vehicles': inspVehs,
          'No. of Vehicles': vehs,
          '% vehicles inspected': vehsCompleted,

          'No. of Inspected tyres': inspTyres,
          'No. of tyres': tyres,
          '% tyres inspected': tyresCompleted,
        }
      })
    },
    vehicleInspectionAnalysisChart() {
      const { inspections } = this.data

      const keys = _.range(8).map(i =>
        moment()
          .startOf('month')
          .add(-7 + i, 'months')
          .format('MMM YY'),
      )
      const inspectionsByMonths = _.groupBy(inspections, i => moment(i.date).format('MMM YY'))
      const vehiclesByMonth = _.mapValues(inspectionsByMonths, insps =>
        _.uniq(insps.map(i => i.tcVehicle && i.tcVehicle.id)),
      )
      return {
        title: { text: 'Vehicle Inspection Analysis' },
        chart: {
          type: 'column',
        },
        xAxis: {
          categories: keys,
        },
        yAxis: {
          min: 0,
          title: {
            text: 'Inspections count',
          },
        },

        series: [
          {
            name: 'Inspections',
            data: keys.map(k => (vehiclesByMonth[k] || []).length),
          },
        ],
      }
    },
    inspectionsTable() {
      const { locations, vehicles } = this.data
      return locations.map(l => {
        const locationVehicles = vehicles.filter(v => v.tcLocation.id === l.id)
        const locationVehiclesCount = locationVehicles.length
        // const locationInspectionsCount = lastMonthInspections.filter(v => v.tcLocation.id === l.id).length
        const inspectedVehiclesCount = locationVehicles.filter(v =>
          this.lastMonthInspections.some(i => i.tcVehicle.id === v.id),
        ).length
        // const twiceInspectedVehiclesCount = locationVehicles.filter(
        //   v => lastMonthInspections.filter(i => i.tcVehicle.id === v.id).length > 1,
        // ).length
        const completed = locationVehiclesCount === 0 ? 0 : inspectedVehiclesCount / locationVehiclesCount
        return {
          Location: l.name,
          'No. of Vehicles': locationVehiclesCount,
          // 'No. of Inspections': locationInspectionsCount,
          'Inspected Vehicles': inspectedVehiclesCount,
          // 'Vehicles Inspected More than Once': twiceInspectedVehiclesCount,
          '% Completed': completed.toLocaleString([], { style: 'percent', maximumFractionDigits: 1 }),
        }
      })
    },
  },
  methods: {
    async run() {
      await this.$validate()
      if (!this.params.tcFleet) {
        throw new tc.SafeError('Fleet is required')
      }
      this.data = null
      const result = {}

      result.locations = await i2s.queryAll({
        query: dataSources.locations,
        variables: {
          where: {
            tcFleet: this.params.tcFleet,
          },
        },
      })

      result.vehicles = await i2s.queryAll({
        query: dataSources.vehicles,
        variables: {
          where: {
            status: 'active',
            tcLocation: { id_in: result.locations.map(l => l.id) },
          },
        },
      })

      result.inspections = await i2s.queryAll({
        query: dataSources.inspections,
        variables: {
          where: {
            tcVehicle: { id_in: result.vehicles.map(l => l.id) },
            type: 'inspection',
            date_gt: moment()
              .startOf('month')
              .add(-7, 'month')
              .toISOString(),
          },
        },
      })

      this.data = result
    },
  },
}
</script>
